using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace thinger.ZmotionECI1408Pro
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();

            this.updateTimer = new Timer();
            this.updateTimer.Interval = 200;
            this.updateTimer.Tick += UpdateTimer_Tick;
            this.updateTimer.Start();


            List<string> result = motion.GetEhList();

            if (result.Count > 0)
            {
                this.cmb_IP.DataSource = result;
                this.cmb_IP.SelectedIndex = 0;
            }
        }

        #region ʵʱ

        /// <summary>
        /// ʵʱ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void UpdateTimer_Tick(object sender, EventArgs e)
        {
            if (motion.InitedOK)
            {

                bool StateX = motion.IsMoving(xAxis);
                this.tssl_StateX.Text = StateX ? "˶" : "ֹͣ";
                this.tssl_StateX.BackColor = StateX ? Color.LimeGreen : Color.Red;
                this.tssl_StateX.ForeColor = StateX ? Color.Black : Color.White;

                bool StateY = motion.IsMoving(yAxis);
                this.tssl_StateY.Text = StateY ? "˶" : "ֹͣ";
                this.tssl_StateY.BackColor = StateY ? Color.LimeGreen : Color.Red;
                this.tssl_StateY.ForeColor = StateY ? Color.Black : Color.White;

                bool StateZ = motion.IsMoving(zAxis);
                this.tssl_StateZ.Text = StateZ ? "˶" : "ֹͣ";
                this.tssl_StateZ.BackColor = StateZ ? Color.LimeGreen : Color.Red;
                this.tssl_StateZ.ForeColor = StateZ ? Color.Black : Color.White;

                this.tssl_VelX.Text = motion.GetVel(xAxis).ToString("f1");
                this.tssl_VelY.Text = motion.GetVel(yAxis).ToString("f1");
                this.tssl_VelZ.Text = motion.GetVel(zAxis).ToString("f1");

                this.tssl_PosX.Text = motion.GetPos(xAxis).ToString("f1");
                this.tssl_PosY.Text = motion.GetPos(yAxis).ToString("f1");
                this.tssl_PosZ.Text = motion.GetPos(zAxis).ToString("f1");

            }
        }

        #endregion

        #region 

        private Zmotion motion = new Zmotion();

        private Timer updateTimer;

        private short xAxis = 0;
        private short yAxis = 2;
        private short zAxis = 1;

        private float velMax = 0.0f;
        private float velMin = 0.0f;

        private float acc = 0.0f;
        private float dec = 0.0f;

        private float sramp = 0.0f;

        private float xcreep = 0.0f;
        private float ycreep = 0.0f;
        private float zcreep = 0.0f;


        private float xhomedis = 0.0f;
        private float yhomedis = 0.0f;
        private float zhomedis = 0.0f;

        private int xhomeio = 24;
        private int yhomeio = 26;
        private int zhomeio = 25;

        private short Axis
        {

            get { return this.rdo_X.Checked ? xAxis : this.rdo_Y.Checked ? yAxis : zAxis; }
        }

        #endregion

        #region Ῠ

        private void btn_Connect_Click(object sender, EventArgs e)
        {
            if (this.btn_Connect.Text == "Ῠ")
            {
                motion = new Zmotion(this.cmb_IP.Text.Trim());

                if (motion.InitCard().IsSuccess)
                {
                    this.btn_Connect.Text = "Ͽ";
                    this.lbl_State.BackColor = Color.Lime;
                    MessageBox.Show("ӳɹ", "ʾ");
                }
                else
                {
                    MessageBox.Show("ʧ", "ʾ");
                }
            }
            else
            {
                if (motion.CloseCard().IsSuccess)
                {
                    this.btn_Connect.Text = "Ῠ";
                    this.lbl_State.BackColor = Color.Red;
                    MessageBox.Show("Ͽӳɹ", "Ͽ");
                }
                else
                {
                    MessageBox.Show("Ͽʧ", "Ͽ");
                }

            }
        }

        #endregion

        #region ò

        private void SetParam()
        {
            velMax = Convert.ToSingle(this.num_velmax.Value);
            velMin = Convert.ToSingle(this.num_velmin.Value);
            acc = Convert.ToSingle(this.num_acc.Value);
            dec = Convert.ToSingle(this.num_dec.Value);
            sramp = Convert.ToSingle(this.num_sramp.Value);

            xcreep = Convert.ToSingle(this.num_creepX.Value);
            ycreep = Convert.ToSingle(this.num_creepY.Value);
            zcreep = Convert.ToSingle(this.num_creepZ.Value);

            xhomedis = Convert.ToSingle(this.num_homeDisX.Value);
            yhomedis = Convert.ToSingle(this.num_homeDisY.Value);
            zhomedis = Convert.ToSingle(this.num_homeDisZ.Value);

            motion.unit0 = Convert.ToInt32(this.num_unit0.Value);
            motion.unit1 = Convert.ToInt32(this.num_unit1.Value);
            motion.unit2 = Convert.ToInt32(this.num_unit2.Value);

        }


        private void SetParam2()
        {
            velMax = Convert.ToSingle(this.num_velmax2.Value);
            velMin = Convert.ToSingle(this.num_velmin2.Value);
            acc = Convert.ToSingle(this.num_acc2.Value);
            dec = Convert.ToSingle(this.num_dec2.Value);
            sramp = Convert.ToSingle(this.num_sramp2.Value);

            motion.unit0 = Convert.ToInt32(this.num_unit0_2.Value);
            motion.unit1 = Convert.ToInt32(this.num_unit1_2.Value);
            motion.unit2 = Convert.ToInt32(this.num_unit2_2.Value);
        }

        #endregion

        #region 㶯
        private void btn_Jog_MouseDown(object sender, MouseEventArgs e)
        {
            if (sender is Button btn)
            {
                if (btn.Tag != null && btn.Tag.ToString().Length > 0)
                {
                    if (btn.Tag.ToString().Contains(';'))
                    {
                        string[] values = btn.Tag.ToString().Split(';');

                        if (values.Length == 2)
                        {
                            //ȡ
                            short axis = Convert.ToInt16(values[0]);
                            //ȡ
                            bool dir = values[1] == "1";
                            //ȡõĲ
                            SetParam();

                            var result = motion.VMove(axis, velMax, dir, velMin, acc, dec, sramp);

                            if (result.IsSuccess == false)
                            {
                                MessageBox.Show("㶯ʧܣ" + result.ErrorMsg, "㶯ʧ");
                            }
                        }
                    }
                }
            }
        }

        private void btn_Jog_MouseUp(object sender, MouseEventArgs e)
        {
            if (sender is Button btn)
            {
                if (btn.Tag != null && btn.Tag.ToString().Length > 0)
                {
                    if (btn.Tag.ToString().Contains(';'))
                    {
                        string[] values = btn.Tag.ToString().Split(';');

                        if (values.Length == 2)
                        {
                            //ȡ
                            short axis = Convert.ToInt16(values[0]);

                            var result = motion.StopAxis(axis);

                            if (result.IsSuccess == false)
                            {
                                MessageBox.Show("㶯ֹͣʧܣ" + result.ErrorMsg, "㶯ֹͣ");
                            }
                        }
                    }
                }
            }
        }

        #endregion

        #region ˶
        private void btn_MoveRelative_Click(object sender, EventArgs e)
        {
            SetParam();

            var result = motion.MoveRelative(Axis, velMax, Convert.ToSingle(this.num_distance.Value), velMin, acc, dec, sramp);

            if (result.IsSuccess == false)
            {
                MessageBox.Show("˶ʧܣ" + result.ErrorMsg, "˶");
            }

        }

        private void btn_MoveAbs_Click(object sender, EventArgs e)
        {
            SetParam();

            var result = motion.MoveAbs(Axis, velMax, Convert.ToSingle(this.num_distance.Value), velMin, acc, dec, sramp);

            if (result.IsSuccess == false)
            {
                MessageBox.Show("˶ʧܣ" + result.ErrorMsg, "˶");
            }
        }

        private void btn_StopAxis_Click(object sender, EventArgs e)
        {
            var result = motion.StopAxis(Axis);
            if (result.IsSuccess == false)
            {
                MessageBox.Show("ֹͣ˶ʧܣ" + result.ErrorMsg, "ֹͣ˶");
            }
        }

        private void btn_ZeroAxis_Click(object sender, EventArgs e)
        {
            var result = motion.ZeroPos(Axis);
            if (result.IsSuccess == false)
            {
                MessageBox.Show("λʧܣ" + result.ErrorMsg, "λ");
            }
        }

        #endregion

        #region 

        private void btn_ZeroX_Click(object sender, EventArgs e)
        {
            Task.Run(() =>
            {
                SetParam();

 

                var result = motion.DirectZeroAxis(xAxis, velMax, xcreep, xhomeio, velMin, acc, dec, 4);

                if (result.IsSuccess == false)
                {
                    MessageBox.Show("Xʧܣ" + result.ErrorMsg, "");
                }

            });
        }

        private void btn_ZeroY_Click(object sender, EventArgs e)
        {
            Task.Run(() =>
            {
                SetParam();

                var result = motion.ZeroAxis(yAxis, velMax, ycreep, yhomeio, yhomedis, velMin, acc, dec, sramp, 4);

                if (result.IsSuccess == false)
                {
                    MessageBox.Show("Yʧܣ" + result.ErrorMsg, "");
                }

            });
        }

        private void btn_ZeroZ_Click(object sender, EventArgs e)
        {
            Task.Run(() =>
            {
                SetParam();

                var result = motion.ZeroAxis(zAxis, velMax, zcreep, zhomeio, zhomedis, velMin, acc, dec, sramp, 4);

                if (result.IsSuccess == false)
                {
                    MessageBox.Show("Zʧܣ" + result.ErrorMsg, "");
                }

            });
        }

        #endregion

        #region ȫֹͣ
        private void btn_HomeAll_Click(object sender, EventArgs e)
        {
            Task.Run(() =>
            {
                SetParam();

                var result = motion.ZeroAxis(zAxis, velMax, zcreep, zhomeio, zhomedis, velMin, acc, dec, sramp, 4);

                if (result.IsSuccess)
                {

                    result = motion.ZeroAxis(xAxis, velMax, xcreep, xhomeio, xhomedis, velMin, acc, dec, sramp, 4);

                    if (result.IsSuccess)
                    {
                        result = motion.ZeroAxis(yAxis, velMax, ycreep, yhomeio, yhomedis, velMin, acc, dec, sramp, 4);

                        if (result.IsSuccess)
                        {
                            MessageBox.Show("ȫɹ", "ȫ");
                        }
                        else
                        {
                            MessageBox.Show("Yʧܣ" + result.ErrorMsg, "ȫ");
                            return;
                        }
                    }
                    else
                    {
                        MessageBox.Show("Xʧܣ" + result.ErrorMsg, "ȫ");
                        return;
                    }

                }
                else
                {
                    MessageBox.Show("Zʧܣ" + result.ErrorMsg, "ȫ");
                    return;
                }
            });
        }

        private void btn_StopAll_Click(object sender, EventArgs e)
        {
            var result = motion.StopAllAxis();

            if (!result.IsSuccess)
            {
                MessageBox.Show("ֹͣʧܣ" + result.ErrorMsg, "ֹͣ");
            }
        }

        #endregion

        #region ˶

        private void rdo_XY_CheckedChanged(object sender, EventArgs e)
        {
            this.num_distanceMoveZ.Enabled = !this.rdo_XY.Checked;
        }


        /// <summary>
        /// ˶
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn_StartMove_Click(object sender, EventArgs e)
        {
            SetParam2();

            //XY˶
            if (this.rdo_XY.Checked)
            {
                short[] axis = new short[] { xAxis, yAxis };
                float[] vel = new float[] { velMax, velMax };
                float[] pos = new float[] { Convert.ToSingle(this.num_distanceMoveX.Value), Convert.ToSingle(this.num_distanceMoveY.Value) };

                float[] velmin = new float[] { velMin, velMin };
                float[] Acc = new float[] { acc, acc };
                float[] Dec = new float[] { dec, dec };
                float[] Sramp = new float[] { sramp, sramp };

                if (rdo_Abs.Checked)
                {
                    Task.Run(() =>
                    {
                        var result = motion.Move2DAbs(axis, vel, pos, velmin, Acc, Dec, Sramp);

                        if (result.IsSuccess == false)
                        {
                            MessageBox.Show("XY˶ʧܣ" + result.ErrorMsg, "˶");
                        }
                    });

                }
                else
                {
                    Task.Run(() =>
                    {
                        var result = motion.Move2DRelative(axis, vel, pos, velmin, Acc, Dec, Sramp);

                        if (result.IsSuccess == false)
                        {
                            MessageBox.Show("XY˶ʧܣ" + result.ErrorMsg, "˶");
                        }
                    });
                }

            }
            else
            {
                short[] axis = new short[] { xAxis, yAxis, zAxis };
                float[] vel = new float[] { velMax, velMax, velMax };
                float[] pos = new float[] { Convert.ToSingle(this.num_distanceMoveX.Value), Convert.ToSingle(this.num_distanceMoveY.Value), Convert.ToSingle(this.num_distanceMoveZ.Value) };

                float[] velmin = new float[] { velMin, velMin, velMin };
                float[] Acc = new float[] { acc, acc, acc };
                float[] Dec = new float[] { dec, dec, dec };
                float[] Sramp = new float[] { sramp, sramp, sramp };

                if (rdo_Abs.Checked)
                {
                    Task.Run(() =>
                    {
                        var result = motion.Move3DAbs(axis, vel, pos, velmin, Acc, Dec, Sramp);

                        if (result.IsSuccess == false)
                        {
                            MessageBox.Show("XYZ˶ʧܣ" + result.ErrorMsg, "˶");
                        }
                    });

                }
                else
                {
                    Task.Run(() =>
                    {
                        var result = motion.Move3DRelative(axis, vel, pos, velmin, Acc, Dec, Sramp);

                        if (result.IsSuccess == false)
                        {
                            MessageBox.Show("XYZ˶ʧܣ" + result.ErrorMsg, "˶");
                        }
                    });
                }

            }

        }

        #endregion
        // ***********************************************************************
//    Assembly       : ¸
//    Created          : 2021-06-05
// ***********************************************************************
//     Copyright by ¸ǸƼ޹˾
//     QQ        2934008828ʦ  
//     WeChatthinger002ʦ
//     ںţ   dotNetλ
//     dotNetλ
//     ֪      dotNetλ
//     ͷ      dotNetλ
//     Ƶţ   dotNetλ
//     ȨУϽ
// ***********************************************************************
        private void FrmMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            motion?.CloseCard();
        }

        private void btn_StartLine_Click(object sender, EventArgs e)
        {
            SetParam2();
            int[] axis;
            float[] distance;
            if (this.rdo_XY.Checked)
            {
                axis = new int[] { xAxis, yAxis };
                distance = new float[] { Convert.ToSingle(this.num_distanceLineX.Value), Convert.ToSingle(this.num_distanceLineY.Value) };
            }
            else
            {
                axis = new int[] { xAxis, yAxis, zAxis };
                distance = new float[] { Convert.ToSingle(this.num_distanceLineX.Value), Convert.ToSingle(this.num_distanceLineY.Value), Convert.ToSingle(this.num_distanceLineZ.Value) };
            }

            if (this.rdo_Abs.Checked)
            {
                Task.Run(() =>
                {
                    var result = motion.MoveLineAbs(axis, distance, velMax, acc, dec);

                    if (result.IsSuccess == false)
                    {
                        MessageBox.Show("ֱ߲岹˶ʧܣ" + result.ErrorMsg, "ֱ߲岹");
                    }
                });
            }
            else
            {
                Task.Run(() =>
                {
                    var result = motion.MoveLineRelative(axis, distance, velMax, acc, dec);

                    if (result.IsSuccess == false)
                    {
                        MessageBox.Show("ֱ߲岹˶ʧܣ" + result.ErrorMsg, "ֱ߲岹");
                    }
                });
            }
        }

        private void btn_StopLine_Click(object sender, EventArgs e)
        {
            var result = motion.StopAllAxis();
            if (!result.IsSuccess)
            {
                MessageBox.Show("ֱ߲岹ֹͣʧܣ" + result.ErrorMsg, "ֹͣ");
            }
        }

        private void btn_StopMove_Click(object sender, EventArgs e)
        {
            var result = motion.StopAllAxis();
            if (!result.IsSuccess)
            {
                MessageBox.Show("˶ֹͣʧܣ" + result.ErrorMsg, "ֹͣ");
            }
        }

        private void btn_CircleMove1_Click(object sender, EventArgs e)
        {
            SetParam2();

            if (this.rdo_XY.Checked)
            {
                int[] axis = new int[] { xAxis, yAxis };
                float[] distance = new float[] { Convert.ToSingle(this.num_distanceCircleX.Value), Convert.ToSingle(this.num_distanceCircleY.Value) };
                float[] midpos = new float[] { Convert.ToSingle(this.num_MiddlePosX.Value), Convert.ToSingle(this.num_MiddlePosY.Value) };
                if (this.rdo_Abs.Checked)
                {
                    Task.Run(() =>
                    {
                        var result = motion.MoveCircleAbs(axis, distance, midpos, velMax, acc, dec, 1);

                        if (result.IsSuccess == false)
                        {
                            MessageBox.Show("Բ岹˶ʧܣ" + result.ErrorMsg, "Բ岹");
                        }

                    });
                }
                else
                {
                    var result = motion.MoveCircleRelative(axis, distance, midpos, velMax, acc, dec, 1);

                    if (result.IsSuccess == false)
                    {
                        MessageBox.Show("Բ岹˶ʧܣ" + result.ErrorMsg, "Բ岹");
                    }

                }

            }
            else
            {
                MessageBox.Show("Ŀǰֻ֧XYԲ岹", "Բ岹");
            }

        }

        private void btn_CircleMove2_Click(object sender, EventArgs e)
        {
            SetParam2();

            if (this.rdo_XY.Checked)
            {
                int[] axis = new int[] { xAxis, yAxis };
                float[] distance = new float[] { Convert.ToSingle(this.num_distanceCircleX.Value), Convert.ToSingle(this.num_distanceCircleY.Value) };
                float[] midpos = new float[] { Convert.ToSingle(this.num_MiddlePosX.Value), Convert.ToSingle(this.num_MiddlePosY.Value) };
                if (this.rdo_Abs.Checked)
                {
                    Task.Run(() =>
                    {
                        var result = motion.MoveCircle2Abs(axis, distance, midpos, velMax, acc, dec);

                        if (result.IsSuccess == false)
                        {
                            MessageBox.Show("Բ岹˶ʧܣ" + result.ErrorMsg, "Բ岹");
                        }

                    });
                }
                else
                {
                    var result = motion.MoveCircle2Relative(axis, distance, midpos, velMax, acc, dec);

                    if (result.IsSuccess == false)
                    {
                        MessageBox.Show("Բ岹˶ʧܣ" + result.ErrorMsg, "Բ岹");
                    }

                }

            }
            else
            {
                MessageBox.Show("Ŀǰֻ֧XYԲ岹", "Բ岹");
            }
        }
    }
}

// ***********************************************************************
//    Assembly       : ¸
//    Created          : 2021-06-05
// ***********************************************************************
//     Copyright by ¸ǸƼ޹˾
//     QQ        2934008828ʦ  
//     WeChatthinger002ʦ
//     ںţ   dotNetλ
//     dotNetλ
//     ֪      dotNetλ
//     ͷ      dotNetλ
//     Ƶţ   dotNetλ
//     ȨУϽ
// ***********************************************************************
